<script setup lang="ts">
    import { computed, ComputedRef, Ref, ref, watch } from 'vue'
    import { ArticleReservation } from '@/logisticServiceOffer/entities/articleReservation/ArticleReservation'
    import { ArticleReservationApi } from '@/logisticServiceOffer/entities/articleReservation/ArticleReservationApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { serviceOfferTrackingCategoryInjectionKey } from '@/shared/constants'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { onBeforeUnmount } from 'vue'
    import { isDefined, requiredInject } from '@/shared/helpers/types'
    import SDialog from '@/interventionServiceOffer/components/global/SDialog.vue'
    import ArticleQuickInventory from '@/logisticServiceOffer/components/ArticleQuickInventory.vue'
    import { logisticServiceOfferInjectionKey } from '@/logisticServiceOffer/constants'

    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )
    const logisticServiceOffer = requiredInject(
        logisticServiceOfferInjectionKey
    )
    const msal = useMsal()

    const userStore = useUserStore(msal)

    const name = 'ArticleReservationListItemComponent'

    interface Props {
        articleReservation: ArticleReservation
        serviceOfferId: ServiceOffer['id']
    }

    const props = defineProps<Props>()
    const emit = defineEmits(['actualiserLesDonnées'])

    const articleReservationApi = new ArticleReservationApi(msal)

    const quantityToIssue = ref<number>(0)
    const isProcessing = ref<boolean>(false)
    const availableQuantity = ref<number>(0)
    const isIssuable: ComputedRef<boolean> = computed<boolean>(() => {
        return (
            Math.min(
                props.articleReservation.quantity,
                props.articleReservation.availableQuantity
            ) > 0
        )
    })
    const inventaireRapideIsActive: Ref<boolean> = ref(false)

    watch(
        () => {
            return props.articleReservation
        },
        (currentArticleReservation, previousArticleReservation) => {
            if (
                currentArticleReservation.quantity !==
                    previousArticleReservation?.quantity ||
                currentArticleReservation.availableQuantity !==
                    previousArticleReservation?.availableQuantity
            ) {
                quantityToIssue.value = Math.min(
                    props.articleReservation.quantity,
                    props.articleReservation.availableQuantity
                )
                availableQuantity.value =
                    props.articleReservation.availableQuantity
            }
        },
        { immediate: true }
    )

    async function issueArticleReservation() {
        // affichage du loader
        isProcessing.value = true

        preventCorrectButtonUsageDisplay()

        // on récupère la quantité réèllement sortie et s'il y a un problème
        // on n'affiche le problème et on ne fait rien
        try {
            const issuedQuantity = (
                await articleReservationApi.issueArticleReservation(
                    props.serviceOfferId,
                    props.articleReservation.id,
                    {
                        articleId: props.articleReservation.articleId,
                        quantity: quantityToIssue.value,
                        warehouseClerkEmail: userStore.currentUser.email,
                        interventionId: props.articleReservation.interventionId,
                        warehouseId: props.articleReservation.warehouseId,
                        storageLocationId:
                            props.articleReservation.storageLocationId,
                    }
                )
            ).quantity

            emitSnackBar(
                `${issuedQuantity} ${props.articleReservation.unit} de ${props.articleReservation.articleDescription} ont étés sortis`,
                'success'
            )
            getAnalyticsProvider().sendEvent(
                serviceOfferTrackingCategory.value,
                'Sortie de stock',
                `${props.articleReservation.articleCode} : ${props.articleReservation.articleDescription}`,
                issuedQuantity
            )
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
        }
        // masquage du loader
        isProcessing.value = false
        emit('actualiserLesDonnées')
    }

    // règles pour la saisie du champ sortie de stock
    const rules = {
        hasEnoughQuantityAvailable: (inputQuantityToIssue: number) => {
            return (
                inputQuantityToIssue <= availableQuantity.value ||
                'Pas assez de quantité disponible en stock'
            )
        },
        hasSomeQuantityToIssue: (inputQuantityToIssue: number) => {
            return inputQuantityToIssue !== 0 || 'Sortez au moins 1 article'
        },
        isQuantityToIssuePositive: (inputQuantityToIssue: number) => {
            return (
                inputQuantityToIssue > 0 ||
                "Saisissez une quantité d'article positive"
            )
        },
    }

    let correctButtonUsageDisplayTimer: number

    function showCorrectButtonUsageAfterDelay() {
        clearTimeout(correctButtonUsageDisplayTimer)
        correctButtonUsageDisplayTimer = window.setTimeout(() => {
            emitSnackBar(
                `Il est nécessaire de double-cliquer pour sortir des articles`,
                'info'
            )
        }, 1000)
    }

    function preventCorrectButtonUsageDisplay() {
        window.clearTimeout(correctButtonUsageDisplayTimer)
    }

    onBeforeUnmount(() => {
        preventCorrectButtonUsageDisplay()
    })
</script>

<template>
    <tr
        :data-cy="`component-${name}-${articleReservation.interventionId}-${articleReservation.articleId}`"
    >
        <td data-cy="article">
            <strong data-cy="code-article">{{
                articleReservation.articleCode
            }}</strong>
            &nbsp;
            {{ articleReservation.articleDescription }}
        </td>
        <td data-cy="unit">
            {{ articleReservation.unit }}
        </td>
        <td data-cy="quantity">
            {{ articleReservation.quantity }}
        </td>
        <td class="d-print-none" data-cy="storage-location">
            {{ articleReservation.storageLocationCode }}
        </td>
        <td class="d-print-none px-0" data-cy="fix-quantity">
            <v-btn
                icon="mdi-clipboard-list-outline"
                variant="plain"
                @click="inventaireRapideIsActive = true"
            ></v-btn>
        </td>
        <td class="d-print-none pl-0" data-cy="available-quantity">
            {{ availableQuantity }}
        </td>
        <td class="d-print-none" data-cy="quantity-to-issue">
            <v-text-field
                v-model.number="quantityToIssue"
                :disabled="!isIssuable"
                :hide-details="true"
                :rules="[
                    rules.hasEnoughQuantityAvailable,
                    rules.hasSomeQuantityToIssue,
                    rules.isQuantityToIssuePositive,
                ]"
                type="number"
                style="min-width: 5em"
                variant="filled"
            ></v-text-field>
        </td>
        <td class="text-center d-print-none">
            <v-progress-circular
                v-if="isProcessing"
                data-cy="processing"
                color="primary"
                indeterminate
            ></v-progress-circular>
            <v-btn
                v-if="
                    isIssuable &&
                    !isProcessing &&
                    userStore.currentUserHasRoleForServiceOffer(
                        'LOGISTIQUE_SORTIR_ARTICLES',
                        serviceOfferId
                    )
                "
                data-cy="stock-issue"
                @click="showCorrectButtonUsageAfterDelay()"
                @dblclick="issueArticleReservation()"
                ><v-icon>mdi-cart-arrow-right</v-icon></v-btn
            >
        </td>
    </tr>
    <s-dialog
        v-model="inventaireRapideIsActive"
        :title="`Inventaire rapide ${articleReservation.articleCode}`"
        display-close-button
        @close-dialog="inventaireRapideIsActive = false"
    >
        <ArticleQuickInventory
            v-if="isDefined(logisticServiceOffer)"
            :article-code="articleReservation.articleCode"
            :type-de-mouvement-id="logisticServiceOffer.typeDInventaireId"
            @mouvement-créé="
                () => {
                    inventaireRapideIsActive = false
                    $emit('actualiserLesDonnées')
                }
            "
        />
        <template #actions>
            <v-btn @click="inventaireRapideIsActive = false"> Annuler </v-btn>
        </template>
    </s-dialog>
</template>
